<template>
  <div v-if="text">
    <!-- Copyable PayReq -->
    <div v-if="copied" class="text-muted text-center pt-4">
      ✔️ Successfully Copied...
    </div>
    <table
      v-else
      id="copyable-text"
      class="text-muted text-center mt-3 mx-2"
      @click="OnTextClicked"
      title="Copy"
    >
      <tr>
        <td class="text-break lines-max-3 pe-2">
          {{ text }}
        </td>
        <td><i class="far fa-copy"></i></td>
      </tr>
    </table>
  </div>
</template>

<script>
import { copyToClipboard } from "../utils/clipboard";
import UserError from "../errors/UserError";

export default {
  data() {
    return {
      copied: false,
    };
  },
  props: ["text"],
  methods: {
    OnTextClicked() {
      copyToClipboard(this.text)
        .then(() => {
          this.copied = true;
        })
        .catch(() => {
          throw new UserError("Copying was unsuccessful");
        });
    },
  },
};
</script>

<style lang="scss" scoped>

#copyable-text {
  cursor: pointer;
}

</style>